// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Batch.Protocol.Models
{
    using System.Linq;

    /// <summary>
    /// A collection of Azure Batch tasks to add.
    /// </summary>
    public partial class TaskAddCollectionParameter
    {
        /// <summary>
        /// Initializes a new instance of the TaskAddCollectionParameter class.
        /// </summary>
        public TaskAddCollectionParameter() { }

        /// <summary>
        /// Initializes a new instance of the TaskAddCollectionParameter class.
        /// </summary>
        /// <param name="value">The collection of tasks to add.</param>
        public TaskAddCollectionParameter(System.Collections.Generic.IList<TaskAddParameter> value)
        {
            Value = value;
        }

        /// <summary>
        /// Gets or sets the collection of tasks to add.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "value")]
        public System.Collections.Generic.IList<TaskAddParameter> Value { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Value == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "Value");
            }
            if (this.Value != null)
            {
                if (this.Value.Count > 100)
                {
                    throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.MaxItems, "Value", 100);
                }
                foreach (var element in this.Value)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
