// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Compute.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Describes a single certificate reference in a Key Vault, and where the
    /// certificate should reside on the VM.
    /// </summary>
    public partial class VaultCertificate
    {
        /// <summary>
        /// Initializes a new instance of the VaultCertificate class.
        /// </summary>
        public VaultCertificate() { }

        /// <summary>
        /// Initializes a new instance of the VaultCertificate class.
        /// </summary>
        public VaultCertificate(string certificateUrl = default(string), string certificateStore = default(string))
        {
            CertificateUrl = certificateUrl;
            CertificateStore = certificateStore;
        }

        /// <summary>
        /// the URL referencing a secret in a Key Vault which contains a
        /// properly formatted certificate.
        /// </summary>
        [JsonProperty(PropertyName = "certificateUrl")]
        public string CertificateUrl { get; set; }

        /// <summary>
        /// the Certificate store in LocalMachine to add the certificate to on
        /// Windows, leave empty on Linux.
        /// </summary>
        [JsonProperty(PropertyName = "certificateStore")]
        public string CertificateStore { get; set; }

    }
}
