// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.DataLake.Analytics.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// A Data Lake Analytics catalog item list.
    /// </summary>
    public partial class CatalogItemList
    {
        /// <summary>
        /// Initializes a new instance of the CatalogItemList class.
        /// </summary>
        public CatalogItemList() { }

        /// <summary>
        /// Initializes a new instance of the CatalogItemList class.
        /// </summary>
        /// <param name="count">the count of items in the list.</param>
        /// <param name="nextLink">the link to the next page of
        /// results.</param>
        public CatalogItemList(int? count = default(int?), string nextLink = default(string))
        {
            Count = count;
            NextLink = nextLink;
        }

        /// <summary>
        /// Gets or sets the count of items in the list.
        /// </summary>
        [JsonProperty(PropertyName = "count")]
        public int? Count { get; set; }

        /// <summary>
        /// Gets or sets the link to the next page of results.
        /// </summary>
        [JsonProperty(PropertyName = "nextLink")]
        public string NextLink { get; set; }

    }
}
