// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Logic.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    public partial class ContentLink
    {
        /// <summary>
        /// Initializes a new instance of the ContentLink class.
        /// </summary>
        public ContentLink() { }

        /// <summary>
        /// Initializes a new instance of the ContentLink class.
        /// </summary>
        public ContentLink(string uri = default(string), string contentVersion = default(string), long? contentSize = default(long?), ContentHash contentHash = default(ContentHash), object metadata = default(object))
        {
            Uri = uri;
            ContentVersion = contentVersion;
            ContentSize = contentSize;
            ContentHash = contentHash;
            Metadata = metadata;
        }

        /// <summary>
        /// Gets or sets gets or sets the content link URI.
        /// </summary>
        [JsonProperty(PropertyName = "uri")]
        public string Uri { get; set; }

        /// <summary>
        /// Gets or sets gets or sets the content version.
        /// </summary>
        [JsonProperty(PropertyName = "contentVersion")]
        public string ContentVersion { get; set; }

        /// <summary>
        /// Gets or sets gets or sets the content size.
        /// </summary>
        [JsonProperty(PropertyName = "contentSize")]
        public long? ContentSize { get; set; }

        /// <summary>
        /// Gets or sets gets or sets the content hash.
        /// </summary>
        [JsonProperty(PropertyName = "contentHash")]
        public ContentHash ContentHash { get; set; }

        /// <summary>
        /// Gets or sets gets or sets the metadata.
        /// </summary>
        [JsonProperty(PropertyName = "metadata")]
        public object Metadata { get; set; }

    }
}
