// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.MachineLearning.CommitmentPlans
{
    using Microsoft.Rest;
    using Microsoft.Rest.Azure;
    using Models;

    /// <summary>
    /// These APIs allow end users to operate on Azure Machine Learning
    /// Commitment Plans resources and their child Commitment Association
    /// resources. They support CRUD operations for commitment plans, get and
    /// list operations for commitment associations, moving commitment
    /// associations between commitment plans, and retrieving commitment plan
    /// usage history.
    /// </summary>
    public partial interface IAzureMLCommitmentPlansManagementClient : System.IDisposable
    {
        /// <summary>
        /// The base URI of the service.
        /// </summary>
        System.Uri BaseUri { get; set; }

        /// <summary>
        /// Gets or sets json serialization settings.
        /// </summary>
        Newtonsoft.Json.JsonSerializerSettings SerializationSettings { get; }

        /// <summary>
        /// Gets or sets json deserialization settings.
        /// </summary>
        Newtonsoft.Json.JsonSerializerSettings DeserializationSettings { get; }

        /// <summary>
        /// Credentials needed for the client to connect to Azure.
        /// </summary>
        Microsoft.Rest.ServiceClientCredentials Credentials { get; }

        /// <summary>
        /// Azure Subscription ID.
        /// </summary>
        string SubscriptionId { get; set; }

        /// <summary>
        /// The version of the Microsoft.MachineLearning resource provider API
        /// to use.
        /// </summary>
        string ApiVersion { get; }

        /// <summary>
        /// Gets or sets the preferred language for the response.
        /// </summary>
        string AcceptLanguage { get; set; }

        /// <summary>
        /// Gets or sets the retry timeout in seconds for Long Running
        /// Operations. Default value is 30.
        /// </summary>
        int? LongRunningOperationRetryTimeout { get; set; }

        /// <summary>
        /// When set to true a unique x-ms-client-request-id value is
        /// generated and included in each request. Default is true.
        /// </summary>
        bool? GenerateClientRequestId { get; set; }


        /// <summary>
        /// Gets the ICommitmentAssociationsOperations.
        /// </summary>
        ICommitmentAssociationsOperations CommitmentAssociations { get; }

        /// <summary>
        /// Gets the ICommitmentPlansOperations.
        /// </summary>
        ICommitmentPlansOperations CommitmentPlans { get; }

        /// <summary>
        /// Gets the IUsageHistoryOperations.
        /// </summary>
        IUsageHistoryOperations UsageHistory { get; }

    }
}
