// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.MachineLearning.WebServices.Models
{
    using System.Linq;

    /// <summary>
    /// Defines an edge within the web service's graph.
    /// </summary>
    public partial class GraphEdge
    {
        /// <summary>
        /// Initializes a new instance of the GraphEdge class.
        /// </summary>
        public GraphEdge() { }

        /// <summary>
        /// Initializes a new instance of the GraphEdge class.
        /// </summary>
        /// <param name="sourceNodeId">The source graph node's
        /// identifier.</param>
        /// <param name="sourcePortId">The identifier of the source node's
        /// port that the edge connects from.</param>
        /// <param name="targetNodeId">The destination graph node's
        /// identifier.</param>
        /// <param name="targetPortId">The identifier of the destination
        /// node's port that the edge connects into.</param>
        public GraphEdge(string sourceNodeId = default(string), string sourcePortId = default(string), string targetNodeId = default(string), string targetPortId = default(string))
        {
            SourceNodeId = sourceNodeId;
            SourcePortId = sourcePortId;
            TargetNodeId = targetNodeId;
            TargetPortId = targetPortId;
        }

        /// <summary>
        /// Gets or sets the source graph node's identifier.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "sourceNodeId")]
        public string SourceNodeId { get; set; }

        /// <summary>
        /// Gets or sets the identifier of the source node's port that the
        /// edge connects from.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "sourcePortId")]
        public string SourcePortId { get; set; }

        /// <summary>
        /// Gets or sets the destination graph node's identifier.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "targetNodeId")]
        public string TargetNodeId { get; set; }

        /// <summary>
        /// Gets or sets the identifier of the destination node's port that
        /// the edge connects into.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "targetPortId")]
        public string TargetPortId { get; set; }

    }
}
