// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Network.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Effective NetworkSecurityGroup
    /// </summary>
    public partial class EffectiveNetworkSecurityGroup
    {
        /// <summary>
        /// Initializes a new instance of the EffectiveNetworkSecurityGroup
        /// class.
        /// </summary>
        public EffectiveNetworkSecurityGroup() { }

        /// <summary>
        /// Initializes a new instance of the EffectiveNetworkSecurityGroup
        /// class.
        /// </summary>
        public EffectiveNetworkSecurityGroup(SubResource networkSecurityGroup = default(SubResource), EffectiveNetworkSecurityGroupAssociation association = default(EffectiveNetworkSecurityGroupAssociation), IList<EffectiveNetworkSecurityRule> effectiveSecurityRules = default(IList<EffectiveNetworkSecurityRule>))
        {
            NetworkSecurityGroup = networkSecurityGroup;
            Association = association;
            EffectiveSecurityRules = effectiveSecurityRules;
        }

        /// <summary>
        /// Gets the id of network security group that is applied
        /// </summary>
        [JsonProperty(PropertyName = "networkSecurityGroup")]
        public SubResource NetworkSecurityGroup { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "association")]
        public EffectiveNetworkSecurityGroupAssociation Association { get; set; }

        /// <summary>
        /// Gets collection of effective security rules
        /// </summary>
        [JsonProperty(PropertyName = "effectiveSecurityRules")]
        public IList<EffectiveNetworkSecurityRule> EffectiveSecurityRules { get; set; }

    }
}
