// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.ServiceBus.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Message Count Details.
    /// </summary>
    public partial class MessageCountDetails
    {
        /// <summary>
        /// Initializes a new instance of the MessageCountDetails class.
        /// </summary>
        public MessageCountDetails() { }

        /// <summary>
        /// Initializes a new instance of the MessageCountDetails class.
        /// </summary>
        public MessageCountDetails(long? activeMessageCount = default(long?), long? deadLetterMessageCount = default(long?), long? scheduledMessageCount = default(long?), long? transferDeadLetterMessageCount = default(long?), long? transferMessageCount = default(long?))
        {
            ActiveMessageCount = activeMessageCount;
            DeadLetterMessageCount = deadLetterMessageCount;
            ScheduledMessageCount = scheduledMessageCount;
            TransferDeadLetterMessageCount = transferDeadLetterMessageCount;
            TransferMessageCount = transferMessageCount;
        }

        /// <summary>
        /// Number of active messages in the queue, topic, or subscription.
        /// </summary>
        [JsonProperty(PropertyName = "activeMessageCount")]
        public long? ActiveMessageCount { get; set; }

        /// <summary>
        /// Number of messages that are dead letters.
        /// </summary>
        [JsonProperty(PropertyName = "deadLetterMessageCount")]
        public long? DeadLetterMessageCount { get; set; }

        /// <summary>
        /// Number scheduled messages.
        /// </summary>
        [JsonProperty(PropertyName = "scheduledMessageCount")]
        public long? ScheduledMessageCount { get; set; }

        /// <summary>
        /// Number of messages transferred into dead letters.
        /// </summary>
        [JsonProperty(PropertyName = "transferDeadLetterMessageCount")]
        public long? TransferDeadLetterMessageCount { get; set; }

        /// <summary>
        /// Number of messages transferred to another queue, topic, or
        /// subscription.
        /// </summary>
        [JsonProperty(PropertyName = "transferMessageCount")]
        public long? TransferMessageCount { get; set; }

    }
}
