// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Response for a restore site request
    /// </summary>
    public partial class RestoreResponse : Resource
    {
        /// <summary>
        /// Initializes a new instance of the RestoreResponse class.
        /// </summary>
        public RestoreResponse() { }

        /// <summary>
        /// Initializes a new instance of the RestoreResponse class.
        /// </summary>
        public RestoreResponse(string location, string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string operationId = default(string))
            : base(location, id, name, type, tags)
        {
            OperationId = operationId;
        }

        /// <summary>
        /// When server starts the restore process, it will return an
        /// OperationId identifying that particular restore operation
        /// </summary>
        [JsonProperty(PropertyName = "properties.operationId")]
        public string OperationId { get; set; }

        /// <summary>
        /// Validate the object. Throws ValidationException if validation fails.
        /// </summary>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
